c luminosity.f
c Compute luninosities from temperatures and radii, assuming simple Planck law.
c Miroslav Broz (miroslav.broz@email.cz), Apr 1st 2016

      subroutine luminosity(T_eff, R_star, nbod, lambda, FWHM,
     :  Lum, Lumtot)

      implicit none
      include '../misc/const.inc'
      integer nbod
      real*8 T_eff(nbod), R_star(nbod), Lum(nbod)
      real*8 lambda, FWHM, Lumtot

c internal
      integer k
      real*8 eps

c functions
      external Lum_func

      real*8 T, R
      common /cb_Lum/ T, R

      data eps /1.d-6/

      Lumtot = 0.d0

      do k = 1, nbod
        T = T_eff(k)
        R = R_star(k)*R_S

        if (T.gt.0.d0) then
          call qtrap(Lum_func, lambda-FWHM/2.d0, lambda+FWHM/2.d0,
     :      eps, Lum(k))
        else
          Lum(k) = 0.d0
        endif

        Lumtot = Lumtot + Lum(k)
      enddo

      return
      end

c-----------------------------------------------------------------------

      real*8 function Lum_func(lambda)
      implicit none
      include '../misc/const.inc'
      real*8 lambda
      real*8 planck
      real*8 T, R
      common /cb_Lum/ T, R

      Lum_func = pi*planck(T,lambda) * 4.d0*pi*R**2

      return
      end


